#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
PSP_MODULE_INFO("anytex", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
extern unsigned char texture_start[]; // テクスチャ参照

#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)

// 描画用Vertex構造体
typedef struct Vertex{
	unsigned short u, v;
	unsigned short color;
	short x, y, z;
}Vertex;
struct Vertex* vertices;

// メインルーチン
int main() {
	pspDebugScreenInit();
	// gu設定一覧
	sceGuInit(); sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_4444, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x44000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST); sceGuEnable(GU_TEXTURE_2D);
	// 設定完了
	sceGuFinish(); sceGuSync(0, GU_SYNC_FINISH);
	sceDisplayWaitVblankStart(); sceGuDisplay(GU_TRUE);
	// ディスプレイリストからメモリ割り当て(5キャラ分)
	vertices = (struct Vertex*)sceGuGetMemory(2*5* sizeof(struct Vertex));
	int i=0;
	while(1){
		sceGuStart(GU_DIRECT,list);
		// テクスチャデータのセット
		sceGuTexMode(GU_PSM_4444, 0, 0, GU_FALSE);
		sceGuTexImage(0, 256, 256, 256, texture_start);
		sceGuTexFunc(GU_TFX_REPLACE, GU_TCC_RGBA);
		sceGuTexFilter(GU_NEAREST, GU_NEAREST);
		for(i=0;i<=4;i++){
			// 0～3までは16x16サイズをヨコ配置
			if(i<=3){
				// スクエア用パラメータをセット。左上(50,5)-右下(85,40)範囲のハコを描画
				vertices[i*2  ].x = 5  + i*30; vertices[i*2  ].y = 5;
				vertices[i*2+1].x = 25 + i*30; vertices[i*2+1].y = 25;
				// テクスチャ値をセット。(0,0)-(63,15)を4分割して4キャラ分
				vertices[i*2  ].u=i*16;    vertices[i*2  ].v=0;
				vertices[i*2+1].u=i*16+15; vertices[i*2+1].v=15;
			}else{ // 4のキャラだけ64x64
				vertices[i*2  ].x = 32; vertices[i*2  ].y = 32;
				vertices[i*2+1].x = 96; vertices[i*2+1].y = 96;
				vertices[i*2  ].u=0;  vertices[i*2  ].v=16;
				vertices[i*2+1].u=64; vertices[i*2+1].v=79;
			}
		}
		// キャラクタ数×2(GU_SPRITES要素数)=i*2を渡してアレイ描画
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, i*2, 0, vertices);
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	return 0;
}
